#include <GMLuaModule.h>
#include <windows.h>

GMOD_MODULE(Load, Unload);

ILuaInterface *gLua = NULL;

struct cmd_t
{
	const char *cmd;
};

void texec(void *cmdv)
{
	cmd_t *cmdt = (cmd_t *)cmdv;

	system(cmdt->cmd);

	delete cmdv;
}

LUA_FUNCTION(exec)
{
	gLua->CheckType(1, GLua::TYPE_STRING);

	cmd_t *cmdt = new cmd_t;

	cmdt->cmd = gLua->GetString(1);

	CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)&texec, (void*)cmdt, NULL, NULL);

	return 0;
}

int Load(lua_State *L)
{
	gLua = Lua();

	gLua->NewGlobalTable("tcmd");

	ILuaObject *tcmd = gLua->GetGlobal("tcmd");
		tcmd->SetMember("exec", exec);
	tcmd->UnReference();

	return 0;
}

int Unload(lua_State *L)
{
	return 0;
}